/* devAsynInt64Array.c */
/***********************************************************************
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
* National Laboratory, and the Regents of the University of
* California, as Operator of Los Alamos National Laboratory, and
* Berliner Elektronenspeicherring-Gesellschaft m.b.H. (BESSY).
* asynDriver is distributed subject to a Software License Agreement
* found in file LICENSE that is included with this distribution.
***********************************************************************/
/*
    Mark Rivers
    February 8, 2012
*/

#include <stdlib.h>
#include <stddef.h>
#include <stdio.h>
#include <string.h>

#include <alarm.h>
#include <recGbl.h>
#include <dbAccess.h>
#include <callback.h>
#include <dbDefs.h>
#include <link.h>
#include <errlog.h>
#include <epicsMutex.h>
#include <cantProceed.h>
#include <dbCommon.h>
#include <dbScan.h>
#include <waveformRecord.h>
#include <recSup.h>
#include <devSup.h>
#include <menuFtype.h>
#include <dbEvent.h>

#include <epicsExport.h>
#include "asynDriver.h"
#include "asynDrvUser.h"
#include "asynEpicsUtils.h"
#include "asynInt64.h"
#include "devAsynXXXTimeSeries.h"

/* The code for this driver is generated by the macro in the include file with macro substitution */

ASYN_XXX_TIME_SERIES_FUNCS("devAsynInt64TimeSeries", asynInt64, asynInt64Type,
                            interruptCallbackInt64, epicsInt64, asynInt64TimeSeries,
                            menuFtypeINT64, menuFtypeUINT64)

